# unless

## Purpose

The logical unless tag renders its body conditionally, based on an expression and/or current environment. The unless tag will render its body unless all of the specified conditions (test and/or environment) are true. The tag will always do the opposite of what the if tag would have done.

## Examples

    <g:unless test="${name == 'fred'}">
         Hello ${name}!
    </g:unless>
    <g:unless env="development">
         Dev mode - debug: $someDebug
    </g:unless>
    <g:unless env="production" test="${cacheEnabled}">
         $cache.getContent('1234')
    </g:unless>

## Description

Attributes

- `test` - The expression to test
- `env` - An environment name

At least one of the attributes must be supplied. If both are supplied, they are combined using AND.